
struct CartesianVIndex{N,T} <: Base.AbstractCartesianIndex{N}
    I::T
    @inline CartesianVIndex(I::T) where {N, T <: Tuple{Vararg{Union{Integer,StaticInt},N}}} = new{N,T}(I)
end
Base.length(::CartesianVIndex{N}) where {N} = N
ArrayInterface.known_length(::Type{<:CartesianVIndex{N}}) where {N} = N
Base.Tuple(i::CartesianVIndex) = i.I
function Base.:(:)(I::CartesianVIndex{N}, J::CartesianVIndex{N}) where {N} 
   CartesianIndices(map((i,j) -> i:j, I.I, J.I))
end
ndim(::Type{<:Base.AbstractCartesianIndex{N}}) where {N} = N
ndim(::Type{<:AbstractArray{N}}) where {N} = N
@generated function CartesianVIndex(I::T) where {T <: Tuple{Vararg{<:Union{Integer,StaticInt,CartesianIndex,CartesianVIndex}}}}
    iexp = Expr(:tuple)
    Tp = T.paramters
    q = Expr(:block)
    for i in eachindex(Tp)
        I_i = Symbol(:I_, i)
        if Tp[i] <: Base.AbstractCartesianIndex
            push!(q.args, Expr(:(=), I_i, Expr(:ref, :I, i)))
            for n in 1:ndim(Tp[i])
                push!(iexp.args, Expr(:ref, I_i, n))
            end
        else
            push!(iexpr.args, I_i)
        end
        
    end
    Expr(:block, Expr(:meta, :inline), Expr(:macrocall, Symobl("@inbounds"), LineNumberNode(@__LINE__, Symbol(@__FILE__)), q), Expr(:call, :CartesianVIndex, iexpr))
end

@inline Base.CartesianIndex(I::Tuple{Vararg{Union{Integer,CartesianIndex,CartesianVIndex,StaticInt}}}) = CartesianVIndex(I)

@generated function _maybestaticfirst(a::Tuple{Vararg{Any,N}}) where {N}
    quote
        $(Expr(:meta,:inline))
        Base.Cartesian.@ntuple $N n -> maybestaticfirst(a[n])
    end
end
@generated function _maybestaticlast(a::Tuple{Vararg{Any,N}}) where {N}
    quote
        $(Expr(:meta,:inline))
        Base.Cartesian.@ntuple $N n -> maybestaticlast(a[n])
    end
end
@inline maybestaticfirst(A::CartesianIndices) = CartesianVIndex(_maybestaticfirst(A.indices))
@inline maybestaticlast(A::CartesianIndices) = CartesianVIndex(_maybestaticlast(A.indices))

